# MAIN IMPORTS ================================================================================================================================================ #
from __future__ import with_statement
import psyco
psyco.full()
import es
import re
import os
import popuplib
import usermsg
import playerlib
import langlib
import gamethread
import cmdlib
import esamlib
# ============================================================================================================================================================= #

# '''''''''''''''''''' # LANG STRINGS # '''''''''''''''''''' #
langs      = {'english':'en', 'portuguese':'pt'}
langDir    = es.getAddonPath('sam') + '/langs/'
word       = langlib.Strings(langDir + 'words.ini')
titles     = langlib.Strings(langDir + 'titles.ini')
admins     = langlib.Strings(langDir + 'admins/admins_base.ini')
groups     = langlib.Strings(langDir + 'admins/groups_base.ini')
addons     = langlib.Strings(langDir + 'addons/addons_base.ini')
base       = langlib.Strings(langDir + 'base.ini')
addonsDesc = langlib.Strings(langDir + 'addons/addons_descs.ini')
manager    = langlib.Strings(langDir + 'manager/manager_base.ini')
pcontrol   = langlib.Strings(langDir + 'pcontrol/pcontrol_base.ini')
# ''''''''''''''''''''''' # COMMON # ''''''''''''''''''''''' #
version    = 'sam_version_full'
menutitle  = 'Source Admin Menu'
tag        = '#redSAM'
lang       = 'english'
pline      = '-' * 47
dev        = 0
# '''''''''''''''''''''''' # PATHS # ''''''''''''''''''''''' #
dir_sounds    = 'cstrike/sound/sam_sounds/'
dbfiles       = 'sam/databases'
dir_addonscfg = 'cstrike/cfg/sam/addons_configs/'
colorspath    = 'cstrike/cfg/sam/colors.txt'
# '''''''''''''''''''''''' # TAGS # '''''''''''''''''''''''' #
servertag     = '#yellow' + titles('server_tag', None, langs[lang])
server_hudtag =             titles('server_tag', None, langs[lang])
adminstag     = '#cyan'   + titles('admins_tag', None, langs[lang])
admins_hudtag =             titles('admins_tag', None, langs[lang])
errortag      = '#Red%s' % word('error', None, langs[lang]).upper()
error_hudtag  = word('error', None, langs[lang]).upper()
updatetag     = '#purpleUPDATE SYSTEM'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

filters = ('#all','#human','#ct','#t','#spec','#alive','#dead')

# * GLOGAL DICTIONARY
cloud = {'newversion':0,'cmds':{},'popups':[]}

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Main menu CMD ###
	cmdlib.registerSayCommand('!sam', samCMD, 'SAM')
	cmdlib.registerClientCommand('sam_menu', samCMD, 'SAM')

	### Server CMDS ###
	cmdlib.registerServerCommand('sam_language', langCMD, 'SAM')
	cmdlib.registerServerCommand('sam_menu_title', tittleCMD, 'SAM')
	cmdlib.registerServerCommand('sam_chat_tag', tagCMD, 'SAM')

	### Say CMDs ###
	cmdlib.registerSayCommand('!rcon', rconCMD, 'SAM')
	cmdlib.registerSayCommand('!rr', rrCMD, 'SAM')
	cmdlib.registerSayCommand('!rs', rsCMD, 'SAM')
	cmdlib.registerSayCommand('!admins', adminsCMD, 'SAM')

	### Downloads Module ###
	es.load('sam/functions/downloads')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Cancel Delays ###
	gamethread.cancelDelayed('sam_rs')

	### Unreg CMDs ###
	cmdlib.unregisterClientCommand('sam_menu')
	cmdlib.unregisterSayCommand('!sam')
	cmdlib.unregisterSayCommand('!rcon')
	cmdlib.unregisterSayCommand('!rr')
	cmdlib.unregisterSayCommand('!rs')
	cmdlib.unregisterSayCommand('!admins')
	cmdlib.unregisterServerCommand('sam_language')
	cmdlib.unregisterServerCommand('sam_menu_title')
	cmdlib.unregisterServerCommand('sam_chat_tag')

	### Unloads ###
	es.unload('sam/functions/downloads')

	### Popups Delete ###
	for name in cloud['popups']: popupDelete(name)

# ============================================================================================================================================================= #
# ======================================================================== MSG SYSTEM ========================================================================= #
# ============================================================================================================================================================= #
def findColors():
	with open(colorspath) as f:
		for (color, r, g, b) in re.findall(r'(#\S+)\s*=\s*(\d+),\s*(\d+),\s*(\d+)', f.read()):
			yield (color, '\x07%02X%02X%02X' % (int(r), int(g), int(b)))
colors = dict(findColors())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def replaceText(text): return reduce(lambda t, r: t.replace(*r), colors.iteritems(), text.replace('&','#'))

# :: FUNCTIONS :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def tell(users, msg, module_tag=None):
	if module_tag == None: usermsg.saytext2(users, 0, replaceText('#default%s #DimGrey| #blue:: #default%s' % (tag,msg)))
	else: usermsg.saytext2(users, 0, replaceText('#default%s #DimGrey| %s #DimGrey| #blue:: #default%s' % (tag,module_tag,msg)))

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def say(users, msg): usermsg.saytext2(users, 0, replaceText('#default%s' % msg))

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def centertell(userid, msg): es.centertell(userid, msg)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def hudhint(users, msg, module_tag=None):
	if module_tag == None: usermsg.hudhint(users, 'SAM |:: %s' % msg)
	else: usermsg.hudhint(users, 'SAM | %s |:: %s' % (module_tag,msg))

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def hudhint2(users, msg): usermsg.hudhint(users, msg)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def keyhint(users, msg): usermsg.keyhint(users, msg)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def motd(users, title, url): usermsg.motd(users, 2, title, url)

# ============================================================================================================================================================= #
# ======================================================================= LANG SYSTEM ========================================================================= #
# ============================================================================================================================================================= #
def lang_word(name): return word(name, None, langs[lang])

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_titles(name,tokens=None): return titles(name,tokens,langs[lang])

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_base(name,tokens=None): return base(name,tokens,langs[lang])

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_admins(name,tokens=None): return admins(name,tokens,langs[lang])

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_groups(name,tokens=None): return groups(name,tokens,langs[lang])

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_pcontrol(name,tokens=None): return pcontrol(name,tokens,langs[lang])

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_manager(name,tokens=None): return manager(name,tokens,langs[lang])

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_addons(name,tokens=None): return addons(name,tokens,langs[lang])

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_addonsDesc(name): return addonsDesc(name,None,langs[lang])

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_addon(addon, name, tokens=None):
	_addon = langlib.Strings(langDir + 'addons/%s/%s.ini' % (addon,addon))
	return _addon(name, tokens, langs[lang])

# ============================================================================================================================================================= #
# ====================================================================== UPDATE SYSTEM ======================================================================== #
# ============================================================================================================================================================= #
def checkUpdate(msg=1):
	try:
		sam        = esamlib.getAddon('sam')
		newversion = sam.currentversion
		if newversion == es.ServerVar(version):
			if msg == 1: tell('#all', lang_base('up_to_date'), updatetag)
		else:
			cloud['newversion'] = newversion
			if msg == 1: tell('#all', lang_base('outdated', {'newversion':newversion}), updatetag)
	except:
		if msg == 1: tell('#all', lang_base('connection_problem'), errortag)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def popupDelete(name):
	if popuplib.exists(name): popuplib.delete(name)
	if not name in cloud['popups']: cloud['popups'].append(name)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getPage(index, itemCount):
	page = 1
	while itemCount <= index:
		itemCount += itemCount
		page += 1
	else: return page

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def sound(target, sound, volume, attenuation): es.emitsound('player', target, sound, volume, attenuation)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def play(target, sound): es.cexec_all(target,'play',sound)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def playall(sound): es.cexec_all('play',sound)

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def samCMD(userid, args):
	base = es.import_addon('sam/base')
	base.menuCMD(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def langCMD(args):
	if args:
		arg = ' '.join(args)
		global lang
		if arg in langs: lang = arg

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def tittleCMD(args):
	if args:
		global menutitle
		menutitle = ' '.join(args)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def tagCMD(args):
	if args:
		global tag
		tag = ' '.join(args)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def rconCMD(userid, args):
	if args:
		admins = es.import_addon('sam/base/manager')
		player = playerlib.getPlayer(userid)
		if admins.isAdmin(player.steamid):
			if admins.checkAccess(player.steamid, 'Remote RCON'):
				if es.exists('variable', args[0]) or es.exists('command', args[0]):
					string = ' '.join(args)
					value  = string.replace(args[0],'').strip(' ')
					escmds = {'es_load':'load','es_unload':'unload','es_reload':'load'}
					es.server.insertcmd(string)
					if args[0].startswith('sam_'): cloud['cmds'][args[0]] = value
					for x in ('sam_','sv_','mp_','rate'):
						if args[0].startswith(x): gamethread.delayed(.1, tell, ('#all', lang_base('rcon_exec_cmd', {'cmd':args[0], 'value':value}), servertag))
					if args[0] in escmds: gamethread.delayed(0.05, tell, ('#all', lang_base('rcon_script_%s' % escmds[args[0]], {'script':value}), servertag))
				else: tell('#all', lang_base('rcon_not_cmd', {'args':args[0]}), servertag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def rrCMD(userid, args):
	admins = es.import_addon('sam/base/manager')
	if admins.isAdmin(es.getplayersteamid(userid)):
		if admins.checkAccess(es.getplayersteamid(userid), 'Server Commands'): es.server.insertcmd('mp_restartgame 3')

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def rsCMD(userid, args):
	admins = es.import_addon('sam/base/manager')
	if admins.isAdmin(es.getplayersteamid(userid)):
		if admins.checkAccess(es.getplayersteamid(userid), 'Server Commands'): rsLoop()

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def adminsCMD(userid, args):
	admins    = es.import_addon('sam/base/manager')
	adminList = [ply.name for ply in playerlib.getPlayerList('#human') if admins.isAdmin(ply.steamid) == True]
	if len(adminList) > 0: tell(userid, '#darkgreen%s#default.' % '#default, #darkgreen'.join(adminList), '#cyanADMINS ONLINE')
	else: tell(userid, lang_base('no_admins_online'), adminstag)

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def round_end(ev):
	for popup in cloud['popups']: popupDelete(popup)
	if cloud['newversion'] == 0 and dev == 0: checkUpdate(0)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def es_map_start(ev):
	for popup in cloud['popups']: popupDelete(popup)
	if cloud['newversion'] == 0 and dev == 0: checkUpdate(0)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def player_activate(ev): es.server.mp_disable_autokick(ev['userid'])

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def rsLoop(num=5):
	if num != 0:
		hudhint2('#all', '*** WARNING ***\nServer restart in %s seconds.' % num)
		gamethread.delayedname(1, 'sam_rs', rsLoop, (num - 1))
	else:
		hudhint2('#all', 'Server restarting now!\nPlease reconnect.')
		es.server.insertcmd('es_unload sam')
		gamethread.delayed( 1, es.server.insertcmd, ('_restart'))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def mpAddon(option, addon):
	base = es.import_addon('sam/base')
	base.addons[option] = addon

# ============================================================================================================================================================= #